searchData={"items":[{"type":"module","title":"LazyDoc","doc":"","ref":"LazyDoc.html"},{"type":"module","title":"Main functionality - LazyDoc","doc":"The module LazyDoc provides a way to extract and organize documentation from Elixir source files by reading them, parsing their abstract syntax tree (AST), and collecting relevant information about modules, functions, and comments.","ref":"LazyDoc.html#module-main-functionality"},{"type":"module","title":"Description - LazyDoc","doc":"It implements functions to read files matching a given path pattern, extract their AST and comments, group function definitions by names and arities, filter out undocumented functions and modules, and retrieve associated documentation for the extracted modules. The module serves as a utility for generating or managing documentation for Elixir projects.","ref":"LazyDoc.html#module-description"},{"type":"function","title":"LazyDoc.docs_per_module/1","doc":"","ref":"LazyDoc.html#docs_per_module/1"},{"type":"function","title":"Parameters - LazyDoc.docs_per_module/1","doc":"- modules - a list of modules to fetch documentation for.","ref":"LazyDoc.html#docs_per_module/1-parameters"},{"type":"function","title":"Description - LazyDoc.docs_per_module/1","doc":"Retrieves the documentation for the specified modules, filtering to include only the functions.","ref":"LazyDoc.html#docs_per_module/1-description"},{"type":"function","title":"Returns - LazyDoc.docs_per_module/1","doc":"A list of tuples containing each module and its corresponding documentation details.","ref":"LazyDoc.html#docs_per_module/1-returns"},{"type":"function","title":"LazyDoc.extract_data_from_files/0","doc":"","ref":"LazyDoc.html#extract_data_from_files/0"},{"type":"function","title":"Parameters - LazyDoc.extract_data_from_files/0","doc":"- patterns - a list of regular expressions used to filter file paths.\n- @global_path - a global variable representing the directory path to search for files.","ref":"LazyDoc.html#extract_data_from_files/0-parameters"},{"type":"function","title":"Description - LazyDoc.extract_data_from_files/0","doc":"Extracts data from files in the specified paths by reading the file contents, parsing them into an abstract syntax tree (AST), and extracting module and function information.","ref":"LazyDoc.html#extract_data_from_files/0-description"},{"type":"function","title":"Returns - LazyDoc.extract_data_from_files/0","doc":"A list of maps, each containing details about the file, including its content, AST, extracted functions, documented functions, undocumented functions, modules, and any comments found.","ref":"LazyDoc.html#extract_data_from_files/0-returns"},{"type":"function","title":"LazyDoc.extract_names/1","doc":"","ref":"LazyDoc.html#extract_names/1"},{"type":"function","title":"Parameters - LazyDoc.extract_names/1","doc":"- ast - The abstract syntax tree (AST) from which names will be extracted.\n- acc - An accumulator that stores the collected names.","ref":"LazyDoc.html#extract_names/1-parameters"},{"type":"function","title":"Description - LazyDoc.extract_names/1","doc":"Extracts module, function, and protocol names from the given abstract syntax tree.","ref":"LazyDoc.html#extract_names/1-description"},{"type":"function","title":"Returns - LazyDoc.extract_names/1","doc":"A list of tuples containing the extracted names and their corresponding structures.","ref":"LazyDoc.html#extract_names/1-returns"},{"type":"function","title":"LazyDoc.filter_documented_functions/2","doc":"","ref":"LazyDoc.html#filter_documented_functions/2"},{"type":"function","title":"Parameters - LazyDoc.filter_documented_functions/2","doc":"- module - the module to process.\n- module_ast - the abstract syntax tree of the module.\n- _code_mod - the code modification that is being applied (unused).\n- functions - a list of functions to filter.","ref":"LazyDoc.html#filter_documented_functions/2-parameters"},{"type":"function","title":"Description - LazyDoc.filter_documented_functions/2","doc":"Filters the provided functions based on their visibility in the documentation.","ref":"LazyDoc.html#filter_documented_functions/2-description"},{"type":"function","title":"Returns - LazyDoc.filter_documented_functions/2","doc":"A tuple containing the module, its abstract syntax tree, and the filtered list of functions.","ref":"LazyDoc.html#filter_documented_functions/2-returns"},{"type":"function","title":"LazyDoc.filter_undocumented_functions/2","doc":"","ref":"LazyDoc.html#filter_undocumented_functions/2"},{"type":"function","title":"Parameters - LazyDoc.filter_undocumented_functions/2","doc":"- module - The name of the module being analyzed.\n- module_ast - The abstract syntax tree (AST) representation of the module.\n- _code_mod - The code representation of the module, not used in the function.\n- functions - A list of functions in the module.","ref":"LazyDoc.html#filter_undocumented_functions/2-parameters"},{"type":"function","title":"Description - LazyDoc.filter_undocumented_functions/2","doc":"Filters the list of functions in a module to identify those that are undocumented.","ref":"LazyDoc.html#filter_undocumented_functions/2-description"},{"type":"function","title":"Returns - LazyDoc.filter_undocumented_functions/2","doc":"A tuple containing the module name, its AST, and the filtered list of undocumented functions.","ref":"LazyDoc.html#filter_undocumented_functions/2-returns"},{"type":"function","title":"LazyDoc.filter_undocumented_modules/1","doc":"","ref":"LazyDoc.html#filter_undocumented_modules/1"},{"type":"function","title":"Parameters - LazyDoc.filter_undocumented_modules/1","doc":"- zip_to_process - a list of tuples containing module information, where each tuple consists of the module name, its abstract syntax tree (AST), code, and function documentation.","ref":"LazyDoc.html#filter_undocumented_modules/1-parameters"},{"type":"function","title":"Description - LazyDoc.filter_undocumented_modules/1","doc":"Filters out modules that do not contain any documentation.","ref":"LazyDoc.html#filter_undocumented_modules/1-description"},{"type":"function","title":"Returns - LazyDoc.filter_undocumented_modules/1","doc":"A list of modules, each represented as a tuple containing the module name, AST, and code.","ref":"LazyDoc.html#filter_undocumented_modules/1-returns"},{"type":"function","title":"LazyDoc.group_docs_different_arities/1","doc":"","ref":"LazyDoc.html#group_docs_different_arities/1"},{"type":"function","title":"Parameters - LazyDoc.group_docs_different_arities/1","doc":"- func_docs - a list of tuples containing function documentation details.","ref":"LazyDoc.html#group_docs_different_arities/1-parameters"},{"type":"function","title":"Description - LazyDoc.group_docs_different_arities/1","doc":"Groups function documentation by function name.","ref":"LazyDoc.html#group_docs_different_arities/1-description"},{"type":"function","title":"Returns - LazyDoc.group_docs_different_arities/1","doc":"a map where each key is a function name and the value is a list of documentation strings associated with that function.","ref":"LazyDoc.html#group_docs_different_arities/1-returns"},{"type":"function","title":"LazyDoc.join_code_from_clauses/1","doc":"","ref":"LazyDoc.html#join_code_from_clauses/1"},{"type":"function","title":"Parameters - LazyDoc.join_code_from_clauses/1","doc":"- names - a list of tuples where each tuple contains a type and a name with code.","ref":"LazyDoc.html#join_code_from_clauses/1-parameters"},{"type":"function","title":"Description - LazyDoc.join_code_from_clauses/1","doc":"Recursively processes a list of name-code tuples to generate a list of joined code based on matching names.","ref":"LazyDoc.html#join_code_from_clauses/1-description"},{"type":"function","title":"Returns - LazyDoc.join_code_from_clauses/1","doc":"A list of functions or tuples based on the input names.","ref":"LazyDoc.html#join_code_from_clauses/1-returns"},{"type":"module","title":"LazyDoc.Application","doc":"","ref":"LazyDoc.Application.html"},{"type":"module","title":"Main functionality - LazyDoc.Application","doc":"The module LazyDoc.Application is responsible for initiating the application process in the LazyDoc system.","ref":"LazyDoc.Application.html#module-main-functionality"},{"type":"module","title":"Description - LazyDoc.Application","doc":"It provides a start function that allows for the initiation of application processes with specified start parameters. The function returns the process identifier of the newly started process, which can be utilized for further interactions within the application.","ref":"LazyDoc.Application.html#module-description"},{"type":"function","title":"LazyDoc.Application.start/2","doc":"","ref":"LazyDoc.Application.html#start/2"},{"type":"function","title":"Parameters - LazyDoc.Application.start/2","doc":"- _start_type - the type of start operation to initiate.\n- _start_args - additional arguments needed for the start operation.","ref":"LazyDoc.Application.html#start/2-parameters"},{"type":"function","title":"Description - LazyDoc.Application.start/2","doc":"Initializes the start operation and returns the process identifier.","ref":"LazyDoc.Application.html#start/2-description"},{"type":"function","title":"Returns - LazyDoc.Application.start/2","doc":"a tuple indicating success and the process identifier.","ref":"LazyDoc.Application.html#start/2-returns"},{"type":"module","title":"LazyDoc.Example","doc":"Documentation for `LazyDoc`.\n\nThis module is an example of autogenerated docs by\nthe task provided.","ref":"LazyDoc.Example.html"},{"type":"function","title":"LazyDoc.Example.func_without_doc/0","doc":"","ref":"LazyDoc.Example.html#func_without_doc/0"},{"type":"function","title":"Parameters - LazyDoc.Example.func_without_doc/0","doc":"- None","ref":"LazyDoc.Example.html#func_without_doc/0-parameters"},{"type":"function","title":"Description - LazyDoc.Example.func_without_doc/0","doc":"Outputs \"Hello world\" to the console.","ref":"LazyDoc.Example.html#func_without_doc/0-description"},{"type":"function","title":"Returns - LazyDoc.Example.func_without_doc/0","doc":"None","ref":"LazyDoc.Example.html#func_without_doc/0-returns"},{"type":"function","title":"LazyDoc.Example.hello/0","doc":"","ref":"LazyDoc.Example.html#hello/0"},{"type":"function","title":"Parameters - LazyDoc.Example.hello/0","doc":"- None","ref":"LazyDoc.Example.html#hello/0-parameters"},{"type":"function","title":"Description - LazyDoc.Example.hello/0","doc":"Returns the atom :world","ref":"LazyDoc.Example.html#hello/0-description"},{"type":"function","title":"Returns - LazyDoc.Example.hello/0","doc":"The atom :world","ref":"LazyDoc.Example.html#hello/0-returns"},{"type":"function","title":"LazyDoc.Example.my_func/1","doc":"","ref":"LazyDoc.Example.html#my_func/1"},{"type":"function","title":"Parameters - LazyDoc.Example.my_func/1","doc":"- n - An integer value used to determine the output string.","ref":"LazyDoc.Example.html#my_func/1-parameters"},{"type":"function","title":"Description - LazyDoc.Example.my_func/1","doc":"Returns a string indicating the identity of the integer passed as an argument.","ref":"LazyDoc.Example.html#my_func/1-description"},{"type":"function","title":"Returns - LazyDoc.Example.my_func/1","doc":"A string representation of the input integer.","ref":"LazyDoc.Example.html#my_func/1-returns"},{"type":"function","title":"LazyDoc.Example.my_func_2/1","doc":"","ref":"LazyDoc.Example.html#my_func_2/1"},{"type":"function","title":"Parameters - LazyDoc.Example.my_func_2/1","doc":"- n - an integer input that determines the output string.","ref":"LazyDoc.Example.html#my_func_2/1-parameters"},{"type":"function","title":"Description - LazyDoc.Example.my_func_2/1","doc":"Generates a string representation based on the provided integer.","ref":"LazyDoc.Example.html#my_func_2/1-description"},{"type":"function","title":"Returns - LazyDoc.Example.my_func_2/1","doc":"A string indicating the corresponding description of the input integer.","ref":"LazyDoc.Example.html#my_func_2/1-returns"},{"type":"behaviour","title":"LazyDoc.Provider","doc":"","ref":"LazyDoc.Provider.html"},{"type":"behaviour","title":"Main functionality - LazyDoc.Provider","doc":"The module LazyDoc.Provider provides a standard interface for making requests to an external service and processing the responses.","ref":"LazyDoc.Provider.html#module-main-functionality"},{"type":"behaviour","title":"Description - LazyDoc.Provider","doc":"It defines a set of callbacks and functions that allow a user to request a prompt, retrieve documents from a response, and interact with models, enabling flexible integration with various providers that conform to this interface.","ref":"LazyDoc.Provider.html#module-description"},{"type":"callback","title":"LazyDoc.Provider.check_parameters?/1","doc":"","ref":"LazyDoc.Provider.html#c:check_parameters?/1"},{"type":"function","title":"LazyDoc.Provider.check_parameters?/2","doc":"","ref":"LazyDoc.Provider.html#check_parameters?/2"},{"type":"function","title":"Parameters - LazyDoc.Provider.check_parameters?/2","doc":"- callback_module - a module that implements a `check_parameters?` function.\n- params - the parameters to be checked for validity.","ref":"LazyDoc.Provider.html#check_parameters?/2-parameters"},{"type":"function","title":"Description - LazyDoc.Provider.check_parameters?/2","doc":"Validates the given parameters using the specified callback module.","ref":"LazyDoc.Provider.html#check_parameters?/2-description"},{"type":"function","title":"Returns - LazyDoc.Provider.check_parameters?/2","doc":"a boolean indicating whether the parameters are valid or not.","ref":"LazyDoc.Provider.html#check_parameters?/2-returns"},{"type":"callback","title":"LazyDoc.Provider.get_docs_from_response/1","doc":"","ref":"LazyDoc.Provider.html#c:get_docs_from_response/1"},{"type":"function","title":"LazyDoc.Provider.get_docs_from_response/2","doc":"","ref":"LazyDoc.Provider.html#get_docs_from_response/2"},{"type":"function","title":"Parameters - LazyDoc.Provider.get_docs_from_response/2","doc":"- callback_module - a module that contains the method to retrieve documents from a response.\n- response - the data response from which to extract documents.","ref":"LazyDoc.Provider.html#get_docs_from_response/2-parameters"},{"type":"function","title":"Description - LazyDoc.Provider.get_docs_from_response/2","doc":"Calls the get_docs_from_response method from the specified callback module with the provided response.","ref":"LazyDoc.Provider.html#get_docs_from_response/2-description"},{"type":"function","title":"Returns - LazyDoc.Provider.get_docs_from_response/2","doc":"The documents extracted from the response by the callback module.","ref":"LazyDoc.Provider.html#get_docs_from_response/2-returns"},{"type":"callback","title":"LazyDoc.Provider.model/1","doc":"","ref":"LazyDoc.Provider.html#c:model/1"},{"type":"function","title":"LazyDoc.Provider.model/2","doc":"","ref":"LazyDoc.Provider.html#model/2"},{"type":"function","title":"Parameters - LazyDoc.Provider.model/2","doc":"- callback_module - The module that contains the callback functions.\n- model - The specific model to be processed by the callback module.","ref":"LazyDoc.Provider.html#model/2-parameters"},{"type":"function","title":"Description - LazyDoc.Provider.model/2","doc":"Executes the model function of the provided callback module.","ref":"LazyDoc.Provider.html#model/2-description"},{"type":"function","title":"Returns - LazyDoc.Provider.model/2","doc":"The result from invoking the model function in the callback module with the specified model.","ref":"LazyDoc.Provider.html#model/2-returns"},{"type":"callback","title":"LazyDoc.Provider.request_prompt/4","doc":"","ref":"LazyDoc.Provider.html#c:request_prompt/4"},{"type":"function","title":"LazyDoc.Provider.request_prompt/5","doc":"","ref":"LazyDoc.Provider.html#request_prompt/5"},{"type":"function","title":"Parameters - LazyDoc.Provider.request_prompt/5","doc":"- callback_module - module responsible for handling the request.\n- prompt - the text input or query that needs to be processed.\n- model - the specific model to be used for generating a response.\n- token - authentication token required for the request.\n- params - optional parameters that can be passed to customize the request.","ref":"LazyDoc.Provider.html#request_prompt/5-parameters"},{"type":"function","title":"Description - LazyDoc.Provider.request_prompt/5","doc":"Handles a request for generating a response based on the given prompt using the specified model.","ref":"LazyDoc.Provider.html#request_prompt/5-description"},{"type":"function","title":"Returns - LazyDoc.Provider.request_prompt/5","doc":"the result of the request processed by the callback_module.","ref":"LazyDoc.Provider.html#request_prompt/5-returns"},{"type":"module","title":"LazyDoc.Providers.GithubAi","doc":"","ref":"LazyDoc.Providers.GithubAi.html"},{"type":"module","title":"Main functionality - LazyDoc.Providers.GithubAi","doc":"The module LazyDoc.Providers.GithubAi provides a way of interacting with the Github AI API for prompt-based communication and response generation.","ref":"LazyDoc.Providers.GithubAi.html#module-main-functionality"},{"type":"module","title":"Description - LazyDoc.Providers.GithubAi","doc":"It implements the behavior Provider, offering a standardized method to request and retrieve responses from AI models hosted on the Github AI platform. Key operations include sending prompts, constructing API requests, and processing responses.","ref":"LazyDoc.Providers.GithubAi.html#module-description"},{"type":"function","title":"LazyDoc.Providers.GithubAi.check_parameters?/1","doc":"","ref":"LazyDoc.Providers.GithubAi.html#check_parameters?/1"},{"type":"function","title":"Parameters - LazyDoc.Providers.GithubAi.check_parameters?/1","doc":"- params - a keyword list containing parameters to check for validity.","ref":"LazyDoc.Providers.GithubAi.html#check_parameters?/1-parameters"},{"type":"function","title":"Description - LazyDoc.Providers.GithubAi.check_parameters?/1","doc":"Verifies whether all provided parameters are among the allowed list of parameters.","ref":"LazyDoc.Providers.GithubAi.html#check_parameters?/1-description"},{"type":"function","title":"Returns - LazyDoc.Providers.GithubAi.check_parameters?/1","doc":"true if all parameters are valid, false otherwise.","ref":"LazyDoc.Providers.GithubAi.html#check_parameters?/1-returns"},{"type":"function","title":"LazyDoc.Providers.GithubAi.get_docs_from_response/1","doc":"","ref":"LazyDoc.Providers.GithubAi.html#get_docs_from_response/1"},{"type":"function","title":"Parameters - LazyDoc.Providers.GithubAi.get_docs_from_response/1","doc":"- response - a `%Req.Response{}` struct containing the response data.","ref":"LazyDoc.Providers.GithubAi.html#get_docs_from_response/1-parameters"},{"type":"function","title":"Description - LazyDoc.Providers.GithubAi.get_docs_from_response/1","doc":"Extracts the message content from the first choice in the response body.","ref":"LazyDoc.Providers.GithubAi.html#get_docs_from_response/1-description"},{"type":"function","title":"Returns - LazyDoc.Providers.GithubAi.get_docs_from_response/1","doc":"The content of the message as a string.","ref":"LazyDoc.Providers.GithubAi.html#get_docs_from_response/1-returns"},{"type":"function","title":"LazyDoc.Providers.GithubAi.model/1","doc":"","ref":"LazyDoc.Providers.GithubAi.html#model/1"},{"type":"function","title":"Parameters - LazyDoc.Providers.GithubAi.model/1","doc":"- model - an atom representing the type of model to retrieve. It can be one of the following: :codestral, :gpt_4o, or :gpt_4o_mini.","ref":"LazyDoc.Providers.GithubAi.html#model/1-parameters"},{"type":"function","title":"Description - LazyDoc.Providers.GithubAi.model/1","doc":"Retrieves the name of the model based on the provided symbol.","ref":"LazyDoc.Providers.GithubAi.html#model/1-description"},{"type":"function","title":"Returns - LazyDoc.Providers.GithubAi.model/1","doc":"The name of the model as a string corresponding to the given atom.","ref":"LazyDoc.Providers.GithubAi.html#model/1-returns"},{"type":"function","title":"LazyDoc.Providers.GithubAi.req_query/4","doc":"","ref":"LazyDoc.Providers.GithubAi.html#req_query/4"},{"type":"function","title":"Parameters - LazyDoc.Providers.GithubAi.req_query/4","doc":"- prompt - The input text that the model will respond to.\n- model - The specific model to be used for generating a response.\n- token - The authentication token required to access the model.\n- params - Additional parameters for controlling the generation, such as temperature, top_p, and max_tokens.","ref":"LazyDoc.Providers.GithubAi.html#req_query/4-parameters"},{"type":"function","title":"Description - LazyDoc.Providers.GithubAi.req_query/4","doc":"Prepares a request to the specified model with the given prompt and parameters.","ref":"LazyDoc.Providers.GithubAi.html#req_query/4-description"},{"type":"function","title":"Returns - LazyDoc.Providers.GithubAi.req_query/4","doc":"A configured request object ready to be sent to the API.","ref":"LazyDoc.Providers.GithubAi.html#req_query/4-returns"},{"type":"function","title":"LazyDoc.Providers.GithubAi.request_prompt/4","doc":"","ref":"LazyDoc.Providers.GithubAi.html#request_prompt/4"},{"type":"function","title":"Parameters - LazyDoc.Providers.GithubAi.request_prompt/4","doc":"- prompt - the text input that guides the generated response.\n- model - the AI model used to process the prompt.\n- token - the authorization token required for making the request.\n- params - optional additional parameters for the request.","ref":"LazyDoc.Providers.GithubAi.html#request_prompt/4-parameters"},{"type":"function","title":"Description - LazyDoc.Providers.GithubAi.request_prompt/4","doc":"Sends a request to the AI model with the provided prompt and parameters.","ref":"LazyDoc.Providers.GithubAi.html#request_prompt/4-description"},{"type":"function","title":"Returns - LazyDoc.Providers.GithubAi.request_prompt/4","doc":"The response from the AI model based on the provided prompt and parameters.","ref":"LazyDoc.Providers.GithubAi.html#request_prompt/4-returns"},{"type":"task","title":"mix lazy_doc","doc":"","ref":"Mix.Tasks.LazyDoc.html"},{"type":"task","title":"Main functionality - mix lazy_doc","doc":"The module Mix.Tasks.LazyDoc provides a Mix task for processing source files to extract and format documentation for Elixir modules and functions.","ref":"Mix.Tasks.LazyDoc.html#module-main-functionality"},{"type":"task","title":"Description - mix lazy_doc","doc":"It enables the extraction of documentation using AI to enhance the documentation generation process, verifying and formatting documentation as per specified requirements. It handles reading the source code, interacting with a provider for documentation prompts, and writing the results back in a structured format.","ref":"Mix.Tasks.LazyDoc.html#module-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.docs_are_ok?/1","doc":"","ref":"Mix.Tasks.LazyDoc.html#docs_are_ok?/1"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.docs_are_ok?/1","doc":"- docs - a binary string that represents documentation text.","ref":"Mix.Tasks.LazyDoc.html#docs_are_ok?/1-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.docs_are_ok?/1","doc":"Checks if the provided documentation string is formatted correctly with an appropriate `@doc` tag.","ref":"Mix.Tasks.LazyDoc.html#docs_are_ok?/1-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.docs_are_ok?/1","doc":"true if the documentation matches the expected format, false otherwise.","ref":"Mix.Tasks.LazyDoc.html#docs_are_ok?/1-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.docs_to_module_doc_node/3","doc":"","ref":"Mix.Tasks.LazyDoc.html#docs_to_module_doc_node/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.docs_to_module_doc_node/3","doc":"- docs - the documentation string that needs to be converted into an Abstract Syntax Tree (AST).\n- acc_ast - the accumulator Abstract Syntax Tree that will be updated.\n- module_ast - the module's AST where the documentation will be inserted.","ref":"Mix.Tasks.LazyDoc.html#docs_to_module_doc_node/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.docs_to_module_doc_node/3","doc":"Converts a documentation string into an Elixir AST and inserts it into the specified module AST.","ref":"Mix.Tasks.LazyDoc.html#docs_to_module_doc_node/3-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.docs_to_module_doc_node/3","doc":"The updated accumulator Abstract Syntax Tree after the documentation has been inserted.","ref":"Mix.Tasks.LazyDoc.html#docs_to_module_doc_node/3-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.insert_doc_for_function/4","doc":"","ref":"Mix.Tasks.LazyDoc.html#insert_doc_for_function/4"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.insert_doc_for_function/4","doc":"- ast - the abstract syntax tree representing the module.\n- name_func - the name of the function to be documented.\n- ast_doc - the documentation to be inserted for the function.\n- module_ast - the abstract syntax tree of the module where the function resides.","ref":"Mix.Tasks.LazyDoc.html#insert_doc_for_function/4-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.insert_doc_for_function/4","doc":"Inserts documentation for a specified function within a given module.","ref":"Mix.Tasks.LazyDoc.html#insert_doc_for_function/4-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.insert_doc_for_function/4","doc":"The modified abstract syntax tree with the new documentation for the function added.","ref":"Mix.Tasks.LazyDoc.html#insert_doc_for_function/4-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.insert_module_doc/3","doc":"","ref":"Mix.Tasks.LazyDoc.html#insert_module_doc/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.insert_module_doc/3","doc":"- ast - the abstract syntax tree to be transformed.\n- module_ast - the specific module's abstract syntax tree that is being targeted for documentation.\n- ast_doc - the documentation string to be inserted into the module.","ref":"Mix.Tasks.LazyDoc.html#insert_module_doc/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.insert_module_doc/3","doc":"Inserts documentation into the specified module's AST, either as a new block or by prepending it to an existing block.","ref":"Mix.Tasks.LazyDoc.html#insert_module_doc/3-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.insert_module_doc/3","doc":"The modified abstract syntax tree with the documentation inserted into the desired module.","ref":"Mix.Tasks.LazyDoc.html#insert_module_doc/3-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.insert_nodes_in_module/7","doc":"","ref":"Mix.Tasks.LazyDoc.html#insert_nodes_in_module/7"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.insert_nodes_in_module/7","doc":"- module - the module in which the nodes will be inserted.\n- module_ast - the abstract syntax tree representation of the module.\n- functions - a list of function tuples containing function name atoms and their string representations.\n- final_prompt - the prompt string used for generating documentation.\n- provider_mod - the module responsible for provider-specific requests.\n- model_text - the text input to the model used for processing the prompt.\n- token - the authorization token for API requests.\n- params - additional parameters passed to the request.\n- acc - the accumulator for building the resulting abstract syntax tree.","ref":"Mix.Tasks.LazyDoc.html#insert_nodes_in_module/7-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.insert_nodes_in_module/7","doc":"Inserts documentation nodes into a module based on specified functions and prompts.","ref":"Mix.Tasks.LazyDoc.html#insert_nodes_in_module/7-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.insert_nodes_in_module/7","doc":"The updated abstract syntax tree with documentation nodes inserted.","ref":"Mix.Tasks.LazyDoc.html#insert_nodes_in_module/7-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.proccess_files/1","doc":"","ref":"Mix.Tasks.LazyDoc.html#proccess_files/1"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.proccess_files/1","doc":"- entries - a list of entries containing module and function information for processing.","ref":"Mix.Tasks.LazyDoc.html#proccess_files/1-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.proccess_files/1","doc":"Processes a list of entries to generate documentation based on the specified provider configuration.","ref":"Mix.Tasks.LazyDoc.html#proccess_files/1-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.proccess_files/1","doc":"None, the function writes processed documentation to files.","ref":"Mix.Tasks.LazyDoc.html#proccess_files/1-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.run/1","doc":"","ref":"Mix.Tasks.LazyDoc.html#run/1"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.run/1","doc":"- _command_line_args - command line arguments passed to the function.","ref":"Mix.Tasks.LazyDoc.html#run/1-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.run/1","doc":"Starts required applications and processes configuration, while extracting data from files.","ref":"Mix.Tasks.LazyDoc.html#run/1-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.run/1","doc":"None","ref":"Mix.Tasks.LazyDoc.html#run/1-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.write_to_file/2","doc":"","ref":"Mix.Tasks.LazyDoc.html#write_to_file/2"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.write_to_file/2","doc":"- file - the name of the file to which the data will be written.\n- ast - the Abstract Syntax Tree (AST) representation to be converted to a string and written to the file.","ref":"Mix.Tasks.LazyDoc.html#write_to_file/2-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.write_to_file/2","doc":"Writes the string representation of the given AST to the specified file.","ref":"Mix.Tasks.LazyDoc.html#write_to_file/2-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.write_to_file/2","doc":"None","ref":"Mix.Tasks.LazyDoc.html#write_to_file/2-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.write_to_file_formatted/3","doc":"","ref":"Mix.Tasks.LazyDoc.html#write_to_file_formatted/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.write_to_file_formatted/3","doc":"- file - The path to the file where the formatted output will be written.\n- ast - The abstract syntax tree (AST) that needs to be converted to a string representation.\n- comments - Optional comments to include in the formatted output.","ref":"Mix.Tasks.LazyDoc.html#write_to_file_formatted/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.write_to_file_formatted/3","doc":"Formats the given abstract syntax tree and writes it to the specified file.","ref":"Mix.Tasks.LazyDoc.html#write_to_file_formatted/3-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.write_to_file_formatted/3","doc":"The result of the file write operation, indicating success or failure.","ref":"Mix.Tasks.LazyDoc.html#write_to_file_formatted/3-returns"},{"type":"task","title":"mix lazy_doc.check","doc":"","ref":"Mix.Tasks.LazyDoc.Check.html"},{"type":"task","title":"Main functionality - mix lazy_doc.check","doc":"The module Mix.Tasks.LazyDoc.Check is designed to facilitate the checking of documentation for functions and modules within a codebase using the LazyDoc application.","ref":"Mix.Tasks.LazyDoc.Check.html#module-main-functionality"},{"type":"task","title":"Description - mix lazy_doc.check","doc":"It initializes the LazyDoc application, identifies undocumented functions and modules across specified files, and exits with an appropriate status code based on the presence of undocumented elements. Warnings are logged for any undocumented functions and modules encountered during the check.","ref":"Mix.Tasks.LazyDoc.Check.html#module-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.Check.get_undocumented_functions/2","doc":"","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_functions/2"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Check.get_undocumented_functions/2","doc":"- entry_functions - a list of functions categorized by module.\n- file - the file in which the modules and functions are defined.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_functions/2-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Check.get_undocumented_functions/2","doc":"Iterates through the provided list of entry functions, checks for undocumented functions, and prints warnings if any are found.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_functions/2-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.Check.get_undocumented_functions/2","doc":"a list of modules containing undocumented functions.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_functions/2-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.Check.get_undocumented_modules/2","doc":"","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_modules/2"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Check.get_undocumented_modules/2","doc":"- modules - a list of tuples containing module names and their associated metadata.\n- file - a string representing the file name where undocumented modules are found.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_modules/2-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Check.get_undocumented_modules/2","doc":"Logs a warning for each undocumented module and the corresponding file.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_modules/2-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.Check.get_undocumented_modules/2","doc":"true if there are undocumented modules, otherwise false.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_modules/2-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.Check.print_warnings/3","doc":"","ref":"Mix.Tasks.LazyDoc.Check.html#print_warnings/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Check.print_warnings/3","doc":"- functions - a list of functions to be checked for documentation.\n- mod - the name of the module containing the functions.\n- file - the name of the file where the module is defined.","ref":"Mix.Tasks.LazyDoc.Check.html#print_warnings/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Check.print_warnings/3","doc":"Logs a warning for each function in the provided list that lacks documentation and logs the filename containing the module.","ref":"Mix.Tasks.LazyDoc.Check.html#print_warnings/3-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.Check.print_warnings/3","doc":"nil","ref":"Mix.Tasks.LazyDoc.Check.html#print_warnings/3-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.Check.run/1","doc":"","ref":"Mix.Tasks.LazyDoc.Check.html#run/1"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Check.run/1","doc":"- _command_line_args - command line arguments passed to the function.","ref":"Mix.Tasks.LazyDoc.Check.html#run/1-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Check.run/1","doc":"Initializes the LazyDoc application, runs a Mix task to load the application configuration, and extracts data from files to check for undocumented functions and modules.","ref":"Mix.Tasks.LazyDoc.Check.html#run/1-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.Check.run/1","doc":"exits with a status code indicating the presence of undocumented code (1 for undocumented, 0 for none).","ref":"Mix.Tasks.LazyDoc.Check.html#run/1-returns"},{"type":"task","title":"mix lazy_doc.clean","doc":"","ref":"Mix.Tasks.LazyDoc.Clean.html"},{"type":"task","title":"Main functionality - mix lazy_doc.clean","doc":"The module Mix.Tasks.LazyDoc.Clean provides a task for cleaning up documentation in the codebase.","ref":"Mix.Tasks.LazyDoc.Clean.html#module-main-functionality"},{"type":"task","title":"Description - mix lazy_doc.clean","doc":"It implements functionality for removing documentation for specific functions from the abstract syntax tree (AST) of Elixir modules. The task starts the LazyDoc application, checks the application configuration, extracts documentation data from files, and processes each entry to remove the documentation for specified functions, updating the files accordingly.","ref":"Mix.Tasks.LazyDoc.Clean.html#module-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.Clean.clean_tree?/0","doc":"","ref":"Mix.Tasks.LazyDoc.Clean.html#clean_tree?/0"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Clean.clean_tree?/0","doc":"- None","ref":"Mix.Tasks.LazyDoc.Clean.html#clean_tree?/0-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Clean.clean_tree?/0","doc":"Checks if there are any uncommitted changes in the git working directory.","ref":"Mix.Tasks.LazyDoc.Clean.html#clean_tree?/0-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.Clean.clean_tree?/0","doc":"Returns true if the working directory is clean, otherwise it returns false.","ref":"Mix.Tasks.LazyDoc.Clean.html#clean_tree?/0-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.Clean.delete_doc_from_ast/3","doc":"","ref":"Mix.Tasks.LazyDoc.Clean.html#delete_doc_from_ast/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Clean.delete_doc_from_ast/3","doc":"- ast - the abstract syntax tree representing the module's source code.\n- module_ast - the name of the module where the function is defined.\n- name_func - the name of the function to be deleted from the module.","ref":"Mix.Tasks.LazyDoc.Clean.html#delete_doc_from_ast/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Clean.delete_doc_from_ast/3","doc":"Traverses the given abstract syntax tree to remove the specified function from the module's definitions.","ref":"Mix.Tasks.LazyDoc.Clean.html#delete_doc_from_ast/3-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.Clean.delete_doc_from_ast/3","doc":"The new abstract syntax tree with the specified function removed.","ref":"Mix.Tasks.LazyDoc.Clean.html#delete_doc_from_ast/3-returns"},{"type":"function","title":"Mix.Tasks.LazyDoc.Clean.run/1","doc":"","ref":"Mix.Tasks.LazyDoc.Clean.html#run/1"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Clean.run/1","doc":"- _command_line_args - a list of command-line arguments passed to the function.","ref":"Mix.Tasks.LazyDoc.Clean.html#run/1-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Clean.run/1","doc":"Initializes the LazyDoc application, runs the Mix task for app configuration, extracts data from files, and removes documentation from the AST based on the functions documented.","ref":"Mix.Tasks.LazyDoc.Clean.html#run/1-description"},{"type":"function","title":"Returns - Mix.Tasks.LazyDoc.Clean.run/1","doc":"nil","ref":"Mix.Tasks.LazyDoc.Clean.html#run/1-returns"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}